>From 762dd3f241001943fc1afea8b1d0844f8bfe0d81 Mon Sep 17 00:00:00 2001
From: Abhishek Koneru <akoneru@redhat.com>
Date: Thu, 14 Mar 2013 16:25:14 -0400
Subject: [PATCH] 	Updated pkispawn/pkidestroy manpages with the steps
 involved during the Interactive mode installation. 	A
 brief description of all the parameters asked during the
 installation is provided.

	#Ticket 471
---
 base/deploy/man/man8/pkidestroy.8 |    5 +++
 base/deploy/man/man8/pkispawn.8   |   84 +++++++++++++++++++++++++++++++++++++
 2 files changed, 89 insertions(+)

diff --git a/base/deploy/man/man8/pkidestroy.8 b/base/deploy/man/man8/pkidestroy.8
index 676b806da24f8f40986ba629660cd5caf8ec1760..d3dc025d08c20ae9a272da8a0d19fd99b78b900f 100644
--- a/base/deploy/man/man8/pkidestroy.8
+++ b/base/deploy/man/man8/pkidestroy.8
@@ -44,6 +44,11 @@ Prints additional help information.
 Displays verbose information about the installation.  This flag can be provided multiple times to increase verbosity.  See
 .B pkidestroy -h 
 for details.
+.TP
+\fBNote:\fP
+If the -s option is not specified, \fBpkidestroy\fP
+prompts to enter the subsystem to be un-installed. Similarly the instance name is asked, if the -i option is not specified.  
+
 
 .SH BUGS
 Report bugs to http://bugzilla.redhat.com.
diff --git a/base/deploy/man/man8/pkispawn.8 b/base/deploy/man/man8/pkispawn.8
index c5361c3b0a31aefc884e23a71f5feff96474013d..b6c6dbd12fb4af76c1db8636fd0769d1664ebff2 100644
--- a/base/deploy/man/man8/pkispawn.8
+++ b/base/deploy/man/man8/pkispawn.8
@@ -269,6 +269,90 @@ Then, the \fBpkispawn\fP command is run again:
 .PP
 .B pkispawn -s CA -f myconfig.txt
 
+.SS Interactive Mode
+
+If no options are specified, pkispawn will provide an interactive menu to collect the parameters needed to install
+the Dogtag instance.  Note that only the most basic installation options are provided.  This includes root CAs,
+KRAs, OCSPs and TKS, connecting to the LDAP port of a directory server.  More complicated setups such as: cloned subsystems, subordinate or externally signed CAs, subsystems that connect to the directory server using LDAPS, and subsystems that are customized beyond the options described below -  require the use of a configuration file with the
+-f option.
+
+The interactive option is most useful for those users getting familiar with Dogtag.  The parameters collected are
+written to the installation file of the subsystem, which can be found at \fB/var/lib/pki/<instance name>/<subststem>/deployment.cfg.\fP
+
+The following parameters are queried interactively during the installation process:
+ 
+   \fB[Choosing a subsystem type to install]\fP 
+
+   \fISubsystem (CA/KRA/OCSP/TKS):\fP
+      the type of subsystem to be installed. Prompted when the -s option is not specified.  The default value chosen is \fB[CA].\fP
+
+-- When the -f <configuration filename> is not specified:
+
+   \fB[Providing instance specific parameters]\fP 
+
+   \fBInstance name:\fP 
+      the name of the tomcat instance in which the subsystem is to be installed. The default value is \fB[pki-tomcat].\fP
+      \fBNote:\fP Only one subsystem of a given type (CA, KRA, OCSP, TKS) can exist within a given instance.
+  
+   \fIHTTP port:\fP
+      the http port of the Tomcat instance. The default value is \fB[8080].\fP
+  
+   \fISecure HTTP port:\fP
+      the https port of the Tomcat instance. The default value is \fB[8443].\fP
+
+   \fIAJP port:\fP
+      the ajp port of the Tomcat instance. The default value is \fB[8009].\fP
+
+   \fIManagement port:\fP
+      the management port of the Tomcat instance. The default value is \fB[8005].\fP
+
+   \fB[Setting up the Administrator user]\fP
+
+   \fIUsername:\fP
+      the username of the administrator of this subsystem. The default value is \fB[caadmin/kraadmin/tksadmin/ocspadmin].\fP
+
+   \fIPassword:\fP
+      password for the administrator user.
+
+   \fIImport certificate:\fP 
+      An optional parameter that can be used to import an already available CA admin certificate into this instance.
+
+   \fIExport certificate:\fP
+      setup the path where the admin certificate of this <subsystem> should be stored. The default value is \fB[/root/.pki/pki-tomcat/[ca/kra/tks/ocsp]_admin.cert].\fP
+  
+   \fB[Specify the 389 Directory Server to be used for the internal database]\fP
+
+   \fIHostname:\fP
+      Hostname of the directory server instance.  The default value is the hostname of the system. 
+   
+   \fIPort:\fP
+      Port for the directory server instance. The default value is \fB[389].\fP
+
+   \fIBase DN:\fP
+      the Base DN to be used for the internal database for this subsystem. The default value is \fB[o=pki-tomcat-<subsystem>].\fP
+
+   \fIBind DN:\fP
+      the bind DN required to connect for the directory server. This user must have sufficient permissions to install the required schema and database.  The default value is \fB[cn=Directory Manager].\fP
+
+   \fIPassword:\fP
+      password for the bind DN.
+
+   \fB[Setting up the Security Domain properties]\fP
+
+   \fIName:\fP
+      the name of the security domain. Default value: <DNS domain name> Security Domain.
+
+   \fB[Properties in this section asked while installing a KRA / TKS / OCSP]\fP
+
+     \fIHostname:\fP 
+        the hostname for the security domain CA. The default value is the hostname of this system.
+     \fISecure HTTP port:\fP 
+        the https port for the security domain. The default value is \fB[8443].\fP
+     \fIUsername:\fP 
+        the username of the security domain administrator of the CA. The default value is \fB[caadmin].\fP
+     \fIPassword:\fP 
+        password for the security domain administrator.
+
 .SH BUGS
 Report bugs to http://bugzilla.redhat.com.
 
-- 
1.7.10.2